exports.print = function (data) {
    if (data.errNum == 0) {
        printToday(data.retData.today, data.retData.city);
        printForecast(data.retData.forecast);
    } else {
        console.log(data.errMsg.red);
    }
};

function printToday(today, city) {
    var todayStr = "\n " + city.bold + "天气 ".bold + today.type.magenta;
    todayStr += "  当前温度 " + today.curTemp.green;
    todayStr += "  最低温度 " + today.lowtemp.blue;
    todayStr += "  最高温度 " + today.hightemp.red;
    todayStr += "  风力 " + today.fengli.yellow;
    todayStr += "  风向 " + today.fengxiang.yellow;
    todayStr += getAQI(today.aqi);
    todayStr += "\n";
    console.log(todayStr);
    today.index.forEach(function (item, index) {
        console.log(" " + (++index) + "." + item.name + " " + item.index.magenta + " " + item.details.gray + "\n");
    });
}

function printForecast(forecast) {
    console.log(" 未来四天预报~".cyan + "\n");
    forecast.forEach(function (data) {
        var str = " " + data.date + " " + data.type.magenta;
        str += " 最低温度 " + data.lowtemp.blue;
        str += "  最高温度 " + data.hightemp.red;
        str += "  风力 " + data.fengli.yellow;
        str += "  风向 " + data.fengxiang.yellow;
        str += "\n";
        console.log(str);
    });
}

function getAQI(aqi) {
    if (!aqi) {
        return "";
    } else if (aqi <= 50) {
        return "  空气质量指数 " + (aqi + " 优").green;
    } else if (aqi <= 100) {
        return "  空气质量指数 " + (aqi + " 良").green;
    } else if (aqi <= 150) {
        return "  空气质量指数 " + (aqi + " 轻度污染").yellow;
    } else if (aqi <= 200) {
        return "  空气质量指数 " + (aqi + " 中度污染").yellow;
    } else if (aqi <= 300) {
        return "  空气质量指数 " + (aqi + " 重度污染").red;
    } else {
        return "  空气质量指数 " + (aqi + " 严重污染").red;
    }
}
